SDL_mouse.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_video.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_mouse.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_BUTTON(X) (1 << ((X)-1))
#define | SDL_BUTTON_LEFT 1
#define | SDL_BUTTON_MIDDLE 2
#define | SDL_BUTTON_RIGHT 3
#define | SDL_BUTTON_X1 4
#define | SDL_BUTTON_X2 5
#define | SDL_BUTTON_LMASK SDL_BUTTON(SDL_BUTTON_LEFT)
#define | SDL_BUTTON_MMASK SDL_BUTTON(SDL_BUTTON_MIDDLE)
#define | SDL_BUTTON_RMASK SDL_BUTTON(SDL_BUTTON_RIGHT)
#define | SDL_BUTTON_X1MASK SDL_BUTTON(SDL_BUTTON_X1)
#define | SDL_BUTTON_X2MASK SDL_BUTTON(SDL_BUTTON_X2)

## Enumerations

enum | SDL_SystemCursor { SDL_SYSTEM_CURSOR_ARROW, SDL_SYSTEM_CURSOR_IBEAM, SDL_SYSTEM_CURSOR_WAIT, SDL_SYSTEM_CURSOR_CROSSHAIR, SDL_SYSTEM_CURSOR_WAITARROW, SDL_SYSTEM_CURSOR_SIZENWSE, SDL_SYSTEM_CURSOR_SIZENESW, SDL_SYSTEM_CURSOR_SIZEWE, SDL_SYSTEM_CURSOR_SIZENS, SDL_SYSTEM_CURSOR_SIZEALL, SDL_SYSTEM_CURSOR_NO, SDL_SYSTEM_CURSOR_HAND, SDL_NUM_SYSTEM_CURSORS }
| Cursor types for SDL_CreateSystemCursor(). More...
enum | SDL_MouseWheelDirection { SDL_MOUSEWHEEL_NORMAL, SDL_MOUSEWHEEL_FLIPPED }
| Scroll direction types for the Scroll event. More...

## Functions

SDL_Window * | SDL_GetMouseFocus (void)
| Get the window which currently has mouse focus. More...
Uint32 | SDL_GetMouseState (int *x, int *y)
| Retrieve the current state of the mouse. More...
Uint32 | SDL_GetGlobalMouseState (int *x, int *y)
| Get the current state of the mouse, in relation to the desktop. More...
Uint32 | SDL_GetRelativeMouseState (int *x, int *y)
| Retrieve the relative state of the mouse. More...
void | SDL_WarpMouseInWindow (SDL_Window *window, int x, int y)
| Moves the mouse to the given position within the window. More...
int | SDL_WarpMouseGlobal (int x, int y)
| Moves the mouse to the given position in global screen space. More...
int | SDL_SetRelativeMouseMode (SDL_bool enabled)
| Set relative mouse mode. More...
int | SDL_CaptureMouse (SDL_bool enabled)
| Capture the mouse, to track input outside an SDL window. More...
SDL_bool | SDL_GetRelativeMouseMode (void)
| Query whether relative mouse mode is enabled. More...
SDL_Cursor * | SDL_CreateCursor (const Uint8 *data, const Uint8 *mask, int w, int h, int hot_x, int hot_y)
| Create a cursor, using the specified bitmap data and mask (in MSB format). More...
SDL_Cursor * | SDL_CreateColorCursor (SDL_Surface *surface, int hot_x, int hot_y)
| Create a color cursor. More...
SDL_Cursor * | SDL_CreateSystemCursor (SDL_SystemCursor id)
| Create a system cursor. More...
void | SDL_SetCursor (SDL_Cursor *cursor)
| Set the active cursor. More...
SDL_Cursor * | SDL_GetCursor (void)
| Return the active cursor. More...
SDL_Cursor * | SDL_GetDefaultCursor (void)
| Return the default cursor. More...
void | SDL_FreeCursor (SDL_Cursor *cursor)
| Frees a cursor created with SDL_CreateCursor() or similar functions. More...
int | SDL_ShowCursor (int toggle)
| Toggle whether or not the cursor is shown. More...

## Detailed Description

Include file for SDL mouse event handling.

Definition in file SDL_mouse.h.

## Macro Definition Documentation

## SDL_BUTTON

#define SDL_BUTTON | ( |  | X | ) | (1 << ((X)-1))

Used as a mask when testing buttons in buttonstate.

- Button 1: Left mouse button
- Button 2: Middle mouse button
- Button 3: Right mouse button

Definition at line 281 of file SDL_mouse.h.

Referenced by _mouseStateCheck(), SDL_GetMouseFocus(), and SDL_PrivateSendMouseButton().

## SDL_BUTTON_LEFT

#define SDL_BUTTON_LEFT 1

Definition at line 282 of file SDL_mouse.h.

Referenced by SDL_BWin::_MouseButtonEvent(), _mouseStateCheck(), and loop().

## SDL_BUTTON_LMASK

#define SDL_BUTTON_LMASK SDL_BUTTON(SDL_BUTTON_LEFT)

Definition at line 287 of file SDL_mouse.h.

Referenced by SDLTest_CommonEvent().

## SDL_BUTTON_MIDDLE

#define SDL_BUTTON_MIDDLE 2

Definition at line 283 of file SDL_mouse.h.

Referenced by SDL_BWin::_MouseButtonEvent(), and _mouseStateCheck().

## SDL_BUTTON_MMASK

#define SDL_BUTTON_MMASK SDL_BUTTON(SDL_BUTTON_MIDDLE)

Definition at line 288 of file SDL_mouse.h.

Referenced by SDLTest_CommonEvent().

## SDL_BUTTON_RIGHT

#define SDL_BUTTON_RIGHT 3

Definition at line 284 of file SDL_mouse.h.

Referenced by SDL_BWin::_MouseButtonEvent(), and _mouseStateCheck().

## SDL_BUTTON_RMASK

#define SDL_BUTTON_RMASK SDL_BUTTON(SDL_BUTTON_RIGHT)

Definition at line 289 of file SDL_mouse.h.

Referenced by SDLTest_CommonEvent().

## SDL_BUTTON_X1

#define SDL_BUTTON_X1 4

Definition at line 285 of file SDL_mouse.h.

Referenced by _mouseStateCheck().

## SDL_BUTTON_X1MASK

#define SDL_BUTTON_X1MASK SDL_BUTTON(SDL_BUTTON_X1)

Definition at line 290 of file SDL_mouse.h.

Referenced by SDLTest_CommonEvent().

## SDL_BUTTON_X2

#define SDL_BUTTON_X2 5

Definition at line 286 of file SDL_mouse.h.

Referenced by _mouseStateCheck().

## SDL_BUTTON_X2MASK

#define SDL_BUTTON_X2MASK SDL_BUTTON(SDL_BUTTON_X2)

Definition at line 291 of file SDL_mouse.h.

Referenced by SDLTest_CommonEvent().

## Enumeration Type Documentation

## SDL_MouseWheelDirection

enum SDL_MouseWheelDirection

Scroll direction types for the Scroll event.

Enumerator
SDL_MOUSEWHEEL_NORMAL | The scroll direction is normal
SDL_MOUSEWHEEL_FLIPPED | The scroll direction is flipped / natural

Definition at line 66 of file SDL_mouse.h.

{
SDL_MOUSEWHEEL_NORMAL, /**< The scroll direction is normal */
SDL_MOUSEWHEEL_FLIPPED /**< The scroll direction is flipped / natural */
} SDL_MouseWheelDirection;
SDL_MOUSEWHEEL_NORMAL
Definition: SDL_mouse.h:68
SDL_MOUSEWHEEL_FLIPPED
Definition: SDL_mouse.h:69
SDL_MouseWheelDirection
SDL_MouseWheelDirection
Scroll direction types for the Scroll event.
Definition: SDL_mouse.h:66

## SDL_SystemCursor

enum SDL_SystemCursor

Cursor types for SDL_CreateSystemCursor().

Enumerator
SDL_SYSTEM_CURSOR_ARROW | Arrow
SDL_SYSTEM_CURSOR_IBEAM | I-beam
SDL_SYSTEM_CURSOR_WAIT | Wait
SDL_SYSTEM_CURSOR_CROSSHAIR | Crosshair
SDL_SYSTEM_CURSOR_WAITARROW | Small wait cursor (or Wait if not available)
SDL_SYSTEM_CURSOR_SIZENWSE | Double arrow pointing northwest and southeast
SDL_SYSTEM_CURSOR_SIZENESW | Double arrow pointing northeast and southwest
SDL_SYSTEM_CURSOR_SIZEWE | Double arrow pointing west and east
SDL_SYSTEM_CURSOR_SIZENS | Double arrow pointing north and south
SDL_SYSTEM_CURSOR_SIZEALL | Four pointed arrow pointing north, south, east, and west
SDL_SYSTEM_CURSOR_NO | Slashed circle or crossbones
SDL_SYSTEM_CURSOR_HAND | Hand
SDL_NUM_SYSTEM_CURSORS |

Definition at line 46 of file SDL_mouse.h.

{
SDL_SYSTEM_CURSOR_ARROW, /**< Arrow */
SDL_SYSTEM_CURSOR_IBEAM, /**< I-beam */
SDL_SYSTEM_CURSOR_WAIT, /**< Wait */
SDL_SYSTEM_CURSOR_CROSSHAIR, /**< Crosshair */
SDL_SYSTEM_CURSOR_WAITARROW, /**< Small wait cursor (or Wait if not available) */
SDL_SYSTEM_CURSOR_SIZENWSE, /**< Double arrow pointing northwest and southeast */
SDL_SYSTEM_CURSOR_SIZENESW, /**< Double arrow pointing northeast and southwest */
SDL_SYSTEM_CURSOR_SIZEWE, /**< Double arrow pointing west and east */
SDL_SYSTEM_CURSOR_SIZENS, /**< Double arrow pointing north and south */
SDL_SYSTEM_CURSOR_SIZEALL, /**< Four pointed arrow pointing north, south, east, and west */
SDL_SYSTEM_CURSOR_NO, /**< Slashed circle or crossbones */
SDL_SYSTEM_CURSOR_HAND, /**< Hand */
SDL_NUM_SYSTEM_CURSORS
} SDL_SystemCursor;
SDL_SYSTEM_CURSOR_ARROW
Definition: SDL_mouse.h:48
SDL_SYSTEM_CURSOR_HAND
Definition: SDL_mouse.h:59
SDL_SYSTEM_CURSOR_SIZEALL
Definition: SDL_mouse.h:57
SDL_SYSTEM_CURSOR_SIZEWE
Definition: SDL_mouse.h:55
SDL_SYSTEM_CURSOR_SIZENWSE
Definition: SDL_mouse.h:53
SDL_SystemCursor
SDL_SystemCursor
Cursor types for SDL_CreateSystemCursor().
Definition: SDL_mouse.h:46
SDL_SYSTEM_CURSOR_CROSSHAIR
Definition: SDL_mouse.h:51
SDL_SYSTEM_CURSOR_WAIT
Definition: SDL_mouse.h:50
SDL_NUM_SYSTEM_CURSORS
Definition: SDL_mouse.h:60
SDL_SYSTEM_CURSOR_IBEAM
Definition: SDL_mouse.h:49
SDL_SYSTEM_CURSOR_SIZENESW
Definition: SDL_mouse.h:54
SDL_SYSTEM_CURSOR_NO
Definition: SDL_mouse.h:58
SDL_SYSTEM_CURSOR_SIZENS
Definition: SDL_mouse.h:56
SDL_SYSTEM_CURSOR_WAITARROW
Definition: SDL_mouse.h:52

## Function Documentation

## SDL_CaptureMouse()

int SDL_CaptureMouse | ( | SDL_bool | enabled | ) |

Capture the mouse, to track input outside an SDL window.

Parameters

  enabled | Whether or not to enable capturing

Capturing enables your app to obtain mouse events globally, instead of just within your window. Not all video targets support this function. When capturing is enabled, the current window will get all mouse events, but unlike relative mode, no change is made to the cursor and it is not restrained to your window.

This function may also deny mouse input to other windows–both those in your application and others on the system–so you should use this function sparingly, and in small bursts. For example, you might want to track the mouse while the user is dragging something, until the user releases a mouse button. It is not recommended that you capture the mouse for long periods of time, such as the entire time your app is running.

While captured, mouse events still report coordinates relative to the current (foreground) window, but those coordinates may be outside the bounds of the window (including negative values). Capturing is only allowed for the foreground window. If the window loses focus while capturing, the capture will be disabled automatically.

While capturing is enabled, the current window will have the SDL_WINDOW_MOUSE_CAPTURE flag set.

Returns
  0 on success, or -1 if not supported.

Definition at line 757 of file SDL_mouse.c.

References SDL_Mouse::CaptureMouse, SDL_Window::flags, NULL, SDL_GetKeyboardFocus, SDL_GetMouse(), SDL_SetError, SDL_Unsupported, and SDL_WINDOW_MOUSE_CAPTURE.

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Window *focusWindow;
SDL_bool isCaptured;
if (!mouse->CaptureMouse) {
return SDL_Unsupported();
}
focusWindow = SDL_GetKeyboardFocus();
isCaptured = focusWindow && (focusWindow->flags & SDL_WINDOW_MOUSE_CAPTURE);
if (isCaptured == enabled) {
return 0; /* already done! */
}
if (enabled) {
if (!focusWindow) {
return SDL_SetError("No window has focus");
} else if (mouse->CaptureMouse(focusWindow) == -1) {
return -1; /* CaptureMouse() should call SetError */
}
focusWindow->flags |= SDL_WINDOW_MOUSE_CAPTURE;
} else {
if (mouse->CaptureMouse(NULL) == -1) {
return -1; /* CaptureMouse() should call SetError */
}
focusWindow->flags &= ~SDL_WINDOW_MOUSE_CAPTURE;
}
return 0;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_GetKeyboardFocus
#define SDL_GetKeyboardFocus
Definition: SDL_dynapi_overrides.h:216
SDL_Mouse::CaptureMouse
int(* CaptureMouse)(SDL_Window *window)
Definition: SDL_mouse_c.h:70
SDL_WINDOW_MOUSE_CAPTURE
Definition: SDL_video.h:116
enabled
GLenum GLenum GLsizei const GLuint GLboolean enabled
Definition: SDL_opengl_glext.h:2479
NULL
#define NULL
Definition: begin_code.h:164
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_Window
The type used to identify a window.
Definition: SDL_sysvideo.h:73
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Window::flags
Uint32 flags
Definition: SDL_sysvideo.h:83
SDL_Unsupported
#define SDL_Unsupported()
Definition: SDL_error.h:53

## SDL_CreateColorCursor()

SDL_Cursor* SDL_CreateColorCursor | ( | SDL_Surface * | surface,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Create a color cursor.

See also
  SDL_FreeCursor()

Definition at line 841 of file SDL_mouse.c.

References SDL_Mouse::CreateCursor, cursor, SDL_Mouse::cursors, SDL_Surface::format, SDL_PixelFormat::format, SDL_Surface::h, SDL_Cursor::next, NULL, SDL_ConvertSurfaceFormat, SDL_FreeSurface, SDL_GetMouse(), SDL_PIXELFORMAT_ARGB8888, SDL_SetError, and SDL_Surface::w.

Referenced by SDL_CreateCursor().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Surface *temp = NULL;
SDL_Cursor *cursor;
if (!surface) {
SDL_SetError("Passed NULL cursor surface");
return NULL;
}
if (!mouse->CreateCursor) {
SDL_SetError("Cursors are not currently supported");
return NULL;
}
/* Sanity check the hot spot */
if ((hot_x < 0) || (hot_y < 0) ||
(hot_x >= surface->w) || (hot_y >= surface->h)) {
SDL_SetError("Cursor hot spot doesn't lie within cursor");
return NULL;
}
if (surface->format->format != SDL_PIXELFORMAT_ARGB8888) {
temp = SDL_ConvertSurfaceFormat(surface, SDL_PIXELFORMAT_ARGB8888, 0);
if (!temp) {
return NULL;
}
surface = temp;
}
cursor = mouse->CreateCursor(surface, hot_x, hot_y);
if (cursor) {
cursor->next = mouse->cursors;
mouse->cursors = cursor;
}
SDL_FreeSurface(temp);
return cursor;
}
SDL_PIXELFORMAT_ARGB8888
Definition: SDL_pixels.h:248
SDL_ConvertSurfaceFormat
#define SDL_ConvertSurfaceFormat
Definition: SDL_dynapi_overrides.h:464
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_Surface::h
int h
Definition: SDL_surface.h:73
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_Surface::w
int w
Definition: SDL_surface.h:73
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:99
SDL_Mouse::CreateCursor
SDL_Cursor *(* CreateCursor)(SDL_Surface *surface, int hot_x, int hot_y)
Definition: SDL_mouse_c.h:46
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
cursor
SDL_Cursor * cursor
Definition: testcustomcursor.c:119
NULL
#define NULL
Definition: begin_code.h:164
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_PixelFormat::format
Uint32 format
Definition: SDL_pixels.h:317
hot_x
int uint32_t uint32_t uint32_t uint32_t uint32_t int drmModeModeInfoPtr mode int uint32_t uint32_t uint32_t uint32_t int32_t hot_x
Definition: SDL_kmsdrmsym.h:55

## SDL_CreateCursor()

SDL_Cursor* SDL_CreateCursor | ( | const Uint8 * | data,
|  | const Uint8 * | mask,
|  | int | w,
|  | int | h,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Create a cursor, using the specified bitmap data and mask (in MSB format).

The cursor width must be a multiple of 8 bits.

The cursor is created in black and white according to the following:

data | mask | resulting pixel on screen
0 | 1 | White
1 | 1 | Black
0 | 0 | Transparent
1 | 0 | Inverted color if possible, black if not.

See also
  SDL_FreeCursor()

Definition at line 792 of file SDL_mouse.c.

References cursor, NULL, SDL_Surface::pitch, SDL_Surface::pixels, SDL_CreateColorCursor(), SDL_CreateRGBSurface, and SDL_FreeSurface.

{
SDL_Surface *surface;
SDL_Cursor *cursor;
int x, y;
Uint32 *pixel;
Uint8 datab = 0, maskb = 0;
const Uint32 black = 0xFF000000;
const Uint32 white = 0xFFFFFFFF;
const Uint32 transparent = 0x00000000;
/* Make sure the width is a multiple of 8 */
w = ((w + 7) & ~7);
/* Create the surface from a bitmap */
surface = SDL_CreateRGBSurface(0, w, h, 32,
0x00FF0000,
0x0000FF00,
0x000000FF,
0xFF000000);
if (!surface) {
return NULL;
}
for (y = 0; y < h; ++y) {
pixel = (Uint32 *) ((Uint8 *) surface->pixels + y * surface->pitch);
for (x = 0; x < w; ++x) {
if ((x % 8) == 0) {
datab = *data++;
maskb = *mask++;
}
if (maskb & 0x80) {
*pixel++ = (datab & 0x80) ? black : white;
} else {
*pixel++ = (datab & 0x80) ? black : transparent;
}
datab <<= 1;
maskb <<= 1;
}
}
cursor = SDL_CreateColorCursor(surface, hot_x, hot_y);
SDL_FreeSurface(surface);
return cursor;
}
SDL_CreateColorCursor
SDL_Cursor * SDL_CreateColorCursor(SDL_Surface *surface, int hot_x, int hot_y)
Create a color cursor.
Definition: SDL_mouse.c:841
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
h
GLfloat GLfloat GLfloat GLfloat h
Definition: SDL_opengl_glext.h:1946
surface
EGLSurface surface
Definition: eglext.h:248
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_Cursor
Definition: SDL_mouse_c.h:30
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_Surface::pixels
void * pixels
Definition: SDL_surface.h:75
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
mask
GLenum GLint GLuint mask
Definition: SDL_opengl_glext.h:657
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
cursor
SDL_Cursor * cursor
Definition: testcustomcursor.c:119
NULL
#define NULL
Definition: begin_code.h:164
SDL_CreateRGBSurface
#define SDL_CreateRGBSurface
Definition: SDL_dynapi_overrides.h:444
SDL_Surface::pitch
int pitch
Definition: SDL_surface.h:74
hot_x
int uint32_t uint32_t uint32_t uint32_t uint32_t int drmModeModeInfoPtr mode int uint32_t uint32_t uint32_t uint32_t int32_t hot_x
Definition: SDL_kmsdrmsym.h:55

## SDL_CreateSystemCursor()

SDL_Cursor* SDL_CreateSystemCursor | ( | SDL_SystemCursor | id | ) |

Create a system cursor.

See also
  SDL_FreeCursor()

Definition at line 884 of file SDL_mouse.c.

References SDL_Mouse::CreateSystemCursor, cursor, SDL_Mouse::cursors, SDL_Cursor::next, NULL, SDL_GetMouse(), and SDL_SetError.

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Cursor *cursor;
if (!mouse->CreateSystemCursor) {
SDL_SetError("CreateSystemCursor is not currently supported");
return NULL;
}
cursor = mouse->CreateSystemCursor(id);
if (cursor) {
cursor->next = mouse->cursors;
mouse->cursors = cursor;
}
return cursor;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:99
cursor
SDL_Cursor * cursor
Definition: testcustomcursor.c:119
NULL
#define NULL
Definition: begin_code.h:164
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::CreateSystemCursor
SDL_Cursor *(* CreateSystemCursor)(SDL_SystemCursor id)
Definition: SDL_mouse_c.h:49

## SDL_FreeCursor()

void SDL_FreeCursor | ( | SDL_Cursor * | cursor | ) |

Frees a cursor created with SDL_CreateCursor() or similar functions.

See also
  SDL_CreateCursor()
  SDL_CreateColorCursor()
  SDL_CreateSystemCursor()

Definition at line 970 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::FreeCursor, SDL_Cursor::next, NULL, SDL_GetMouse(), and SDL_SetCursor().

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Cursor *curr, *prev;
if (!cursor) {
return;
}
if (cursor == mouse->def_cursor) {
return;
}
if (cursor == mouse->cur_cursor) {
SDL_SetCursor(mouse->def_cursor);
}
for (prev = NULL, curr = mouse->cursors; curr;
prev = curr, curr = curr->next) {
if (curr == cursor) {
if (prev) {
prev->next = curr->next;
} else {
mouse->cursors = curr->next;
}
if (mouse->FreeCursor) {
mouse->FreeCursor(curr);
}
return;
}
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:908
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:99
SDL_Mouse::FreeCursor
void(* FreeCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:58
NULL
#define NULL
Definition: begin_code.h:164
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:101
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:100

## SDL_GetCursor()

SDL_Cursor* SDL_GetCursor | ( | void |  | ) |

Return the active cursor.

Definition at line 948 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, NULL, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (!mouse) {
return NULL;
}
return mouse->cur_cursor;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
NULL
#define NULL
Definition: begin_code.h:164
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:101

## SDL_GetDefaultCursor()

SDL_Cursor* SDL_GetDefaultCursor | ( | void |  | ) |

Return the default cursor.

Definition at line 959 of file SDL_mouse.c.

References SDL_Mouse::def_cursor, NULL, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (!mouse) {
return NULL;
}
return mouse->def_cursor;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
NULL
#define NULL
Definition: begin_code.h:164
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:100

## SDL_GetGlobalMouseState()

Uint32 SDL_GetGlobalMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Get the current state of the mouse, in relation to the desktop.

This works just like SDL_GetMouseState(), but the coordinates will be reported relative to the top-left of the desktop. This can be useful if you need to track the mouse outside of a specific window and SDL_CaptureMouse() doesn't fit your needs. For example, it could be useful if you need to track the mouse while dragging a window, where coordinates relative to a window might not be in sync at all times.

Note
  SDL_GetMouseState() returns the mouse position as SDL understands it from the last pump of the event queue. This function, however, queries the OS for the current mouse position, and as such, might be a slightly less efficient function. Unless you know what you're doing and have a good reason to use this function, you probably want SDL_GetMouseState() instead.

Parameters

  x | Returns the current X coord, relative to the desktop. Can be NULL.
  y | Returns the current Y coord, relative to the desktop. Can be NULL.

Returns
  The current button state as a bitmask, which can be tested using the SDL_BUTTON(X) macros.

See also
  SDL_GetMouseState

Definition at line 633 of file SDL_mouse.c.

References SDL_Mouse::GetGlobalMouseState, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
int tmpx, tmpy;
/* make sure these are never NULL for the backend implementations... */
if (!x) {
x = &tmpx;
}
if (!y) {
y = &tmpy;
}
*x = *y = 0;
if (!mouse->GetGlobalMouseState) {
return 0;
}
return mouse->GetGlobalMouseState(x, y);
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
SDL_Mouse::GetGlobalMouseState
Uint32(* GetGlobalMouseState)(int *x, int *y)
Definition: SDL_mouse_c.h:73
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Mouse
Definition: SDL_mouse_c.h:43

## SDL_GetMouseFocus()

SDL_Window* SDL_GetMouseFocus | ( | void |  | ) |

Get the window which currently has mouse focus.

Definition at line 124 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_Mouse::focus, i, SDL_Mouse::mouseID, SDL_assert, SDL_BUTTON, SDL_GetMouse(), SDL_RELEASED, and SDL_SendMouseButton().

{
SDL_Mouse *mouse = SDL_GetMouse();
return mouse->focus;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Mouse
Definition: SDL_mouse_c.h:43

## SDL_GetMouseState()

Uint32 SDL_GetMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Retrieve the current state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros, and x and y are set to the mouse cursor position relative to the focus window for the currently selected mouse. You can pass NULL for either x or y.

Definition at line 603 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_Mouse::x, and SDL_Mouse::y.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (x) {
*x = mouse->x;
}
if (y) {
*y = mouse->y;
}
return mouse->buttonstate;
}
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:85
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
SDL_Mouse
Definition: SDL_mouse_c.h:43

## SDL_GetRelativeMouseMode()

SDL_bool SDL_GetRelativeMouseMode | ( | void |  | ) |

Query whether relative mouse mode is enabled.

See also
  SDL_SetRelativeMouseMode()

Definition at line 749 of file SDL_mouse.c.

References SDL_Mouse::relative_mode, and SDL_GetMouse().

{
SDL_Mouse *mouse = SDL_GetMouse();
return mouse->relative_mode;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:87
SDL_Mouse
Definition: SDL_mouse_c.h:43

## SDL_GetRelativeMouseState()

Uint32 SDL_GetRelativeMouseState | ( | int * | x,
|  | int * | y
| ) |  |

Retrieve the relative state of the mouse.

The current button state is returned as a button bitmask, which can be tested using the SDL_BUTTON(X) macros, and x and y are set to the mouse deltas since the last call to SDL_GetRelativeMouseState().

Definition at line 617 of file SDL_mouse.c.

References SDL_Mouse::buttonstate, SDL_GetMouse(), SDL_Mouse::xdelta, and SDL_Mouse::ydelta.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (x) {
*x = mouse->xdelta;
}
if (y) {
*y = mouse->ydelta;
}
mouse->xdelta = 0;
mouse->ydelta = 0;
return mouse->buttonstate;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
SDL_Mouse::buttonstate
Uint32 buttonstate
Definition: SDL_mouse_c.h:85
SDL_Mouse::ydelta
int ydelta
Definition: SDL_mouse_c.h:81
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Mouse::xdelta
int xdelta
Definition: SDL_mouse_c.h:80
SDL_Mouse
Definition: SDL_mouse_c.h:43

## SDL_SetCursor()

void SDL_SetCursor | ( | SDL_Cursor * | cursor | ) |

Set the active cursor.

Definition at line 908 of file SDL_mouse.c.

References SDL_Mouse::cur_cursor, cursor, SDL_Mouse::cursor_shown, SDL_Mouse::cursors, SDL_Mouse::def_cursor, SDL_Mouse::focus, SDL_Cursor::next, NULL, SDL_Mouse::relative_mode, SDL_GetMouse(), SDL_SetError, and SDL_Mouse::ShowCursor.

Referenced by SDL_FreeCursor(), SDL_SetDefaultCursor(), SDL_SetMouseFocus(), SDL_SetRelativeMouseMode(), and SDL_ShowCursor().

{
SDL_Mouse *mouse = SDL_GetMouse();
/* Set the new cursor */
if (cursor) {
/* Make sure the cursor is still valid for this mouse */
if (cursor != mouse->def_cursor) {
SDL_Cursor *found;
for (found = mouse->cursors; found; found = found->next) {
if (found == cursor) {
break;
}
}
if (!found) {
SDL_SetError("Cursor not associated with the current mouse");
return;
}
}
mouse->cur_cursor = cursor;
} else {
if (mouse->focus) {
cursor = mouse->cur_cursor;
} else {
cursor = mouse->def_cursor;
}
}
if (cursor && mouse->cursor_shown && !mouse->relative_mode) {
if (mouse->ShowCursor) {
mouse->ShowCursor(cursor);
}
} else {
if (mouse->ShowCursor) {
mouse->ShowCursor(NULL);
}
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_Mouse::ShowCursor
int(* ShowCursor)(SDL_Cursor *cursor)
Definition: SDL_mouse_c.h:52
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Cursor
Definition: SDL_mouse_c.h:30
SDL_Mouse::cursors
SDL_Cursor * cursors
Definition: SDL_mouse_c.h:99
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:102
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:87
cursor
SDL_Cursor * cursor
Definition: testcustomcursor.c:119
NULL
#define NULL
Definition: begin_code.h:164
SDL_Cursor::next
struct SDL_Cursor * next
Definition: SDL_mouse_c.h:32
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Mouse::cur_cursor
SDL_Cursor * cur_cursor
Definition: SDL_mouse_c.h:101
SDL_Mouse::def_cursor
SDL_Cursor * def_cursor
Definition: SDL_mouse_c.h:100

## SDL_SetRelativeMouseMode()

int SDL_SetRelativeMouseMode | ( | SDL_bool | enabled | ) |

Set relative mouse mode.

Parameters

  enabled | Whether or not to enable relative mode

Returns
  0 on success, or -1 if relative mode is not supported.

While the mouse is in relative mode, the cursor is hidden, and the driver will try to report continuous motion in the current window. Only relative motion events will be delivered, the mouse position will not change.

Note
  This function will flush any pending mouse motion.

See also
  SDL_GetRelativeMouseMode()

Definition at line 698 of file SDL_mouse.c.

References SDL_Mouse::focus, SDL_Window::h, NULL, SDL_Mouse::relative_mode, SDL_Mouse::relative_mode_warp, SDL_Mouse::scale_accum_x, SDL_Mouse::scale_accum_y, SDL_FALSE, SDL_FlushEvent, SDL_GetKeyboardFocus, SDL_GetMouse(), SDL_MOUSEMOTION, SDL_SetCursor(), SDL_SetMouseFocus(), SDL_TRUE, SDL_UpdateWindowGrab(), SDL_WarpMouseInWindow(), SDL_Mouse::SetRelativeMouseMode, ShouldUseRelativeModeWarp(), SDL_Window::w, SDL_Mouse::x, and SDL_Mouse::y.

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_Window *focusWindow = SDL_GetKeyboardFocus();
if (enabled == mouse->relative_mode) {
return 0;
}
if (enabled && focusWindow) {
/* Center it in the focused window to prevent clicks from going through
* to background windows.
*/
SDL_SetMouseFocus(focusWindow);
SDL_WarpMouseInWindow(focusWindow, focusWindow->w/2, focusWindow->h/2);
}
/* Set the relative mode */
if (!enabled && mouse->relative_mode_warp) {
mouse->relative_mode_warp = SDL_FALSE;
} else if (enabled && ShouldUseRelativeModeWarp(mouse)) {
mouse->relative_mode_warp = SDL_TRUE;
} else if (mouse->SetRelativeMouseMode(enabled) < 0) {
if (enabled) {
/* Fall back to warp mode if native relative mode failed */
mouse->relative_mode_warp = SDL_TRUE;
}
}
mouse->relative_mode = enabled;
mouse->scale_accum_x = 0.0f;
mouse->scale_accum_y = 0.0f;
if (mouse->focus) {
SDL_UpdateWindowGrab(mouse->focus);
/* Put the cursor back to where the application expects it */
if (!enabled) {
SDL_WarpMouseInWindow(mouse->focus, mouse->x, mouse->y);
}
}
/* Flush pending mouse motion - ideally we would pump events, but that's not always safe */
SDL_FlushEvent(SDL_MOUSEMOTION);
/* Update cursor visibility */
SDL_SetCursor(NULL);
return 0;
}
SDL_UpdateWindowGrab
void SDL_UpdateWindowGrab(SDL_Window *window)
Definition: SDL_video.c:2427
SDL_Mouse::y
int y
Definition: SDL_mouse_c.h:79
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_Window::w
int w
Definition: SDL_sysvideo.h:80
SDL_Mouse::relative_mode_warp
SDL_bool relative_mode_warp
Definition: SDL_mouse_c.h:88
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_FlushEvent
#define SDL_FlushEvent
Definition: SDL_dynapi_overrides.h:120
SDL_Mouse::SetRelativeMouseMode
int(* SetRelativeMouseMode)(SDL_bool enabled)
Definition: SDL_mouse_c.h:67
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_Mouse::scale_accum_y
float scale_accum_y
Definition: SDL_mouse_c.h:92
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:908
SDL_SetMouseFocus
void SDL_SetMouseFocus(SDL_Window *window)
Definition: SDL_mouse.c:151
SDL_GetKeyboardFocus
#define SDL_GetKeyboardFocus
Definition: SDL_dynapi_overrides.h:216
SDL_WarpMouseInWindow
void SDL_WarpMouseInWindow(SDL_Window *window, int x, int y)
Moves the mouse to the given position within the window.
Definition: SDL_mouse.c:656
SDL_Mouse::relative_mode
SDL_bool relative_mode
Definition: SDL_mouse_c.h:87
SDL_Mouse::scale_accum_x
float scale_accum_x
Definition: SDL_mouse_c.h:91
enabled
GLenum GLenum GLsizei const GLuint GLboolean enabled
Definition: SDL_opengl_glext.h:2479
SDL_Window::h
int h
Definition: SDL_sysvideo.h:80
SDL_Mouse::x
int x
Definition: SDL_mouse_c.h:78
NULL
#define NULL
Definition: begin_code.h:164
SDL_MOUSEMOTION
Definition: SDL_events.h:102
SDL_Window
The type used to identify a window.
Definition: SDL_sysvideo.h:73
SDL_Mouse
Definition: SDL_mouse_c.h:43
ShouldUseRelativeModeWarp
static SDL_bool ShouldUseRelativeModeWarp(SDL_Mouse *mouse)
Definition: SDL_mouse.c:688

## SDL_ShowCursor()

int SDL_ShowCursor | ( | int | toggle | ) |

Toggle whether or not the cursor is shown.

Parameters

  toggle | 1 to show the cursor, 0 to hide it, -1 to query the current state.

Returns
  1 if the cursor is shown, or 0 if the cursor is hidden.

Definition at line 1004 of file SDL_mouse.c.

References SDL_Mouse::cursor_shown, NULL, SDL_FALSE, SDL_GetMouse(), SDL_SetCursor(), and SDL_TRUE.

Referenced by SDL_MouseQuit().

{
SDL_Mouse *mouse = SDL_GetMouse();
SDL_bool shown;
if (!mouse) {
return 0;
}
shown = mouse->cursor_shown;
if (toggle >= 0) {
if (toggle) {
mouse->cursor_shown = SDL_TRUE;
} else {
mouse->cursor_shown = SDL_FALSE;
}
if (mouse->cursor_shown != shown) {
SDL_SetCursor(NULL);
}
}
return shown;
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_SetCursor
void SDL_SetCursor(SDL_Cursor *cursor)
Set the active cursor.
Definition: SDL_mouse.c:908
SDL_Mouse::cursor_shown
SDL_bool cursor_shown
Definition: SDL_mouse_c.h:102
NULL
#define NULL
Definition: begin_code.h:164
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
SDL_Mouse
Definition: SDL_mouse_c.h:43

## SDL_WarpMouseGlobal()

int SDL_WarpMouseGlobal | ( | int | x,
|  | int | y
| ) |  |

Moves the mouse to the given position in global screen space.

Parameters

  x | The x coordinate
  y | The y coordinate

Returns
  0 on success, -1 on error (usually: unsupported by a platform).

Note
  This function generates a mouse motion event

Definition at line 676 of file SDL_mouse.c.

References SDL_GetMouse(), SDL_Unsupported, and SDL_Mouse::WarpMouseGlobal.

{
SDL_Mouse *mouse = SDL_GetMouse();
if (mouse->WarpMouseGlobal) {
return mouse->WarpMouseGlobal(x, y);
}
return SDL_Unsupported();
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Mouse::WarpMouseGlobal
int(* WarpMouseGlobal)(int x, int y)
Definition: SDL_mouse_c.h:64
SDL_Mouse
Definition: SDL_mouse_c.h:43
SDL_Unsupported
#define SDL_Unsupported()
Definition: SDL_error.h:53

## SDL_WarpMouseInWindow()

void SDL_WarpMouseInWindow | ( | SDL_Window * | window,
|  | int | x,
|  | int | y
| ) |  |

Moves the mouse to the given position within the window.

Parameters

  window | The window to move the mouse into, or NULL for the current mouse focus
  x | The x coordinate within the window
  y | The y coordinate within the window

Note
  This function generates a mouse motion event

Definition at line 656 of file SDL_mouse.c.

References SDL_Mouse::focus, SDL_Mouse::mouseID, NULL, SDL_GetMouse(), SDL_SendMouseMotion(), and SDL_Mouse::WarpMouse.

Referenced by SDL_PrivateSendMouseMotion(), and SDL_SetRelativeMouseMode().

{
SDL_Mouse *mouse = SDL_GetMouse();
if (window == NULL) {
window = mouse->focus;
}
if (window == NULL) {
return;
}
if (mouse->WarpMouse) {
mouse->WarpMouse(window, x, y);
} else {
SDL_SendMouseMotion(window, mouse->mouseID, 0, x, y);
}
}
SDL_GetMouse
SDL_Mouse * SDL_GetMouse(void)
Definition: SDL_mouse.c:112
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
SDL_Mouse::focus
SDL_Window * focus
Definition: SDL_mouse_c.h:77
SDL_Mouse::mouseID
SDL_MouseID mouseID
Definition: SDL_mouse_c.h:76
SDL_SendMouseMotion
int SDL_SendMouseMotion(SDL_Window *window, SDL_MouseID mouseID, int relative, int x, int y)
Definition: SDL_mouse.c:237
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
NULL
#define NULL
Definition: begin_code.h:164
SDL_Mouse::WarpMouse
void(* WarpMouse)(SDL_Window *window, int x, int y)
Definition: SDL_mouse_c.h:61
SDL_Mouse
Definition: SDL_mouse_c.h:43